"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.converter = void 0;
var _ = require("lodash");
/* tslint:disable no-var-requires */
var translate = require('translate');
var getNestedValue = function (obj, path) {
    return _.get(obj, path, undefined);
};
var setNestedValue = function (obj, path, value) {
    _.set(obj, path, value);
};
var getRule = function (rules, value) {
    return rules.find(function isType(rule) {
        return rule.type === typeof value;
    });
};
var getTranslate = function (parameters) { return __awaiter(void 0, void 0, void 0, function () {
    var e_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, translate(parameters.value, {
                        from: parameters.from,
                        to: parameters.to,
                        engine: 'libre',
                    })];
            case 1: return [2 /*return*/, _a.sent()];
            case 2:
                e_1 = _a.sent();
                return [2 /*return*/, parameters.value];
            case 3: return [2 /*return*/];
        }
    });
}); };
var converter = function (obj, rules, operations) { return __awaiter(void 0, void 0, void 0, function () {
    var rulesUser, operationsUser, _i, operationsUser_1, operation, value, rule, newValue, newValue;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                rulesUser = rules;
                operationsUser = operations;
                _i = 0, operationsUser_1 = operationsUser;
                _a.label = 1;
            case 1:
                if (!(_i < operationsUser_1.length)) return [3 /*break*/, 7];
                operation = operationsUser_1[_i];
                value = getNestedValue(obj, operation.path);
                if (!(value !== undefined)) return [3 /*break*/, 5];
                rule = getRule(rulesUser, value);
                if (!('string' === typeof value)) return [3 /*break*/, 3];
                operation.parameters.value = value;
                return [4 /*yield*/, getTranslate(operation.parameters)];
            case 2:
                newValue = _a.sent();
                setNestedValue(obj, operation.path, newValue);
                return [3 /*break*/, 4];
            case 3:
                if (rule) {
                    operation.parameters.value = value;
                    newValue = rule.func(operation.parameters);
                    setNestedValue(obj, operation.path, newValue);
                }
                else {
                    console.log('Rule not found for type: ' + typeof value);
                }
                _a.label = 4;
            case 4: return [3 /*break*/, 6];
            case 5:
                console.log('Operation path incorrect: ' + operation.path);
                _a.label = 6;
            case 6:
                _i++;
                return [3 /*break*/, 1];
            case 7: return [2 /*return*/, obj];
        }
    });
}); };
exports.converter = converter;
